movies/urls.py
from django.urls import path

from . import views

app_name = 'movies'
urlpatterns = [
    path('', views.MovieListView.as_view(), name='index'),  # edite esta linha
    path('search/', views.search_movies, name='search'),
    path('create/', views.create_movie, name='create'),
    path('<int:movie_id>/', views.detail_movie, name='detail'),
    path('update/<int:movie_id>/', views.update_movie, name='update'),
    path('delete/<int:movie_id>/', views.delete_movie, name='delete'),
    path('<int:movie_id>/review/', views.create_review, name='review'),
    path('lists/', views.ListListView.as_view(), name='lists'),
    path('lists/create', views.ListCreateView.as_view(), name='create-list'),
]


moviesite/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('staticpages.urls')),
    path('movies/', include('movies.urls')),
    path('admin/', admin.site.urls),
]

staticpages/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path('about/', views.about, name='about'),
    path('', views.index, name='index'),
]

movies/models.py
from django.db import models
from django.conf import settings


class Movie(models.Model):
    name = models.CharField(max_length=255)
    release_year = models.IntegerField()
    poster_url = models.URLField(max_length=200, null=True)

    def __str__(self):
        return f'{self.name} ({self.release_year})'


class Review(models.Model):
    author = models.ForeignKey(settings.AUTH_USER_MODEL,
                               on_delete=models.CASCADE)
    text = models.CharField(max_length=255)
    likes = models.IntegerField(default=0)
    movie = models.ForeignKey(Movie, on_delete=models.CASCADE)

    def __str__(self):
        return f'"{self.text}" - {self.author.username}'


class List(models.Model):
    author = models.ForeignKey(settings.AUTH_USER_MODEL,
                               on_delete=models.CASCADE)
    name = models.CharField(max_length=255)
    movies = models.ManyToManyField(Movie)

    def __str__(self):
        return f'{self.name} by {self.author}'

class Provider(models.Model):
    movie = models.OneToOneField(
        Movie,
        on_delete=models.CASCADE,
        primary_key=True,
    )
    service = models.CharField(max_length=255, blank=True)
    has_flat_price = models.BooleanField(default=False)
    price = models.DecimalField(max_digits=6,
                                decimal_places=2,
                                null=True,
                                blank=True)

    def __str__(self):
        return f'{self.service} @ {self.price if self.price else "flat"}'

staticpages/models.py
from django.db import models

# Create your models here.

movies/forms.py
from django.forms import ModelForm
from .models import Movie, Review, Provider


class MovieForm(ModelForm):
    class Meta:
        model = Movie
        fields = [
            'name',
            'release_year',
            'poster_url',
        ]
        labels = {
            'name': 'Título',
            'release_year': 'Data de Lançamento',
            'poster_url': 'URL do Poster',
        }

class ReviewForm(ModelForm):
    class Meta:
        model = Review
        fields = [
            'author',
            'text',
        ]
        labels = {
            'author': 'Usuário',
            'text': 'Resenha',
        }


class ProviderForm(ModelForm):
    class Meta:
        model = Provider
        fields = [
            'service',
            'has_flat_price',
            'price',
        ]
        labels = {
            'service': 'Serviço de Streaming',
            'has_flat_price': 'FLAT?',
            'price': 'Preço',
        } 

movies/views.py
from django.http import HttpResponseRedirect
from django.urls import reverse, reverse_lazy
from .temp_data import movie_data
from django.shortcuts import render, get_object_or_404
from .models import Movie, Review, List, Provider
from django.views import generic
from .forms import MovieForm, ReviewForm, ProviderForm



class MovieListView(generic.ListView):
    model = Movie
    template_name = 'movies/index.html'

def detail_movie(request, movie_id):
    movie = get_object_or_404(Movie, pk=movie_id)
    context = {'movie': movie}
    return render(request, 'movies/detail.html', context)

class ListListView(generic.ListView):
    model = List
    template_name = 'movies/lists.html'


class ListCreateView(generic.CreateView):
    model = List
    template_name = 'movies/create_list.html'
    fields = ['name', 'author', 'movies']
    success_url = reverse_lazy('movies:lists')

def search_movies(request):
    context = {}
    if request.GET.get('query', False):
        search_term = request.GET['query'].lower()
        movie_list = Movie.objects.filter(name__icontains=search_term)
        context = {"movie_list": movie_list}
    return render(request, 'movies/search.html', context)

def create_review(request, movie_id):
    movie = get_object_or_404(Movie, pk=movie_id)
    if request.method == 'POST':
        form = ReviewForm(request.POST)
        if form.is_valid():
            review_author = form.cleaned_data['author']
            review_text = form.cleaned_data['text']
            review = Review(author=review_author,
                            text=review_text,
                            movie=movie)
            review.save()
            return HttpResponseRedirect(
                reverse('movies:detail', args=(movie_id, )))
    else:
        form = ReviewForm()
    context = {'form': form, 'movie': movie}
    return render(request, 'movies/review.html', context)

def create_movie(request):
    if request.method == 'POST':
        movie_form = MovieForm(request.POST)
        provider_form = ProviderForm(request.POST)
        if movie_form.is_valid():
            movie = Movie(**movie_form.cleaned_data)
            movie.save()
            if provider_form.is_valid(
            ) and provider_form.cleaned_data['service']:
                provider = Provider(movie=movie, **provider_form.cleaned_data)
                provider.save()
            return HttpResponseRedirect(
                reverse('movies:detail', args=(movie.pk, )))
    else:
        movie_form = MovieForm()
        provider_form = ProviderForm()
    context = {'movie_form': movie_form, 'provider_form': provider_form}
    return render(request, 'movies/create.html', context)

def update_movie(request, movie_id):
    movie = get_object_or_404(Movie, pk=movie_id)

    if request.method == "POST":
        form = MovieForm(request.POST)
        if form.is_valid():
            movie.name = form.cleaned_data['name']
            movie.release_year = form.cleaned_data['release_year']
            movie.poster_url = form.cleaned_data['poster_url']
            movie.save()
            return HttpResponseRedirect(
                reverse('movies:detail', args=(movie.id, )))
    else:
        form = MovieForm(
            initial={
                'name': movie.name,
                'release_year': movie.release_year,
                'poster_url': movie.poster_url
            })

    context = {'movie': movie, 'form': form}
    return render(request, 'movies/update.html', context)


def delete_movie(request, movie_id):
    movie = get_object_or_404(Movie, pk=movie_id)

    if request.method == "POST":
        movie.delete()
        return HttpResponseRedirect(reverse('movies:index'))

    context = {'movie': movie}
    return render(request, 'movies/delete.html', context)

staticpages/views.py
from django.shortcuts import render


def index(request):
    context = {}
    return render(request, 'staticpages/index.html', context)


def about(request):
    context = {}
    return render(request, 'staticpages/about.html', context)

movies/templates/movies/create.html
{% extends 'base.html' %}

{% block title %}
Criar Filme
{% endblock title %}

{% block content %}
<h2>Adicionar Filme</h2>

<form action="{% url 'movies:create' %}" method="post">
    {% csrf_token %}
    {{ movie_form.as_p }}
    {{ provider_form.as_p }}
    <button type="submit">Criar</button>
</form>

{% endblock content %}

movies/templates/movies/create_list.html
{% extends 'base.html' %}

{% block title %}
Criar Filme
{% endblock title %}

{% block content %}
<h2>Criar Lista</h2>

<form action="{% url 'movies:create-list' %}" method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Criar</button>
</form>

{% endblock content %}

movies/templates/movies/delete.html
{% extends 'base.html' %}

{% block content %}
<form action="{% url 'movies:delete' movie.id %}" method="post">
    {% csrf_token %}
    <p>
        Você tem certeza que deseja apagar o filme "{{ movie.name }} ({{ movie.release_year }})"?
    </p>
    <button type="submit">Apagar</button>
</form>

{% endblock content %}

movies/templates/movies/detail.html
{% extends 'base.html' %}

{% block title %}
{{ movie.name }} ({{ movie.release_year }}
{% endblock title %}

{% block content %}
<h2>Detalhes do Filme {{ movie.name }} ({{ movie.release_year }})</h2>

<section class="dados-de-filme">
    <img src="{{ movie.poster_url }}" alt="Poster do filme {{ movie.name}}">
    <ul>
        <li>Nome: {{ movie.name }}</li>
        <li>Ano de Lançamento: {{ movie.release_year }} </li>
        {% if movie.provider %}
            <li>Disponibilidade de Streaming: {{ movie.provider.service }} </li>
            {% if movie.provider.has_flat_price %}
                <li>Preço: FLAT </li>
            {% else %}
                <li>Preço: R${{ movie.provider.price }} </li>
            {% endif %}
        {% endif %}
        {% if movie.list_set.all %}
           <li>Incluso nas listas: {{ movie.list_set.all|join:", " }} </li>
        {% endif %}
        <li><a href="{% url 'movies:update' movie.id %}">Editar</a></li>
        <li><a href="{% url 'movies:delete' movie.id %}">Apagar</a></li>
    </ul>
</section>

<hr>

<section>
    <header>
        <h3>Resenhas</h3>
    </header>
    <ul>
        {% if movie.review_set.all %}
            {% for review in movie.review_set.all %}
                <figure>
                    <blockquote>
                        "{{ review.text }}"
                    </blockquote>
                    <figcaption>—{{ review.author }}
                </figure>
            {% endfor %}
        {% else %}
            <p>Ainda não existe nenhuma resenha para este filme.</p>
        {% endif %}
    </ul>
    <hr>

    <a href="{% url 'movies:review' movie.pk %}"><button>Crie sua Resenha</button></a>
</section>


{% endblock content %}

movies/templates/movies/index.html
{% extends 'base.html' %}

{% block content %}
<h2>Todos os Filmes</h2>
<section>
    <p>Muitos resultados? <a href="{% url 'movies:search' %}">Buscar Filmes</a></p>
    <p>Não encontrou o filme? <a href="{% url 'movies:create' %}">Adicionar Novo Filme</a></p>
</section>
{% if movie_list %}
<section class="lista-de-cards">
    {% for movie in movie_list %}
    <article class="card">
        <a href="{% url 'movies:detail' movie.id %}"><img src="{{ movie.poster_url }}"
            alt="Poster do filme {{ movie.name}}"></a> <!-- modifique esta linha -->
        <p>{{ movie.name }} ({{ movie.release_year }})</p>
    </article>
    {% endfor %}
</section>
{% else %}
<p>Não foi encontrado nenhum filme.</p>
{% endif %}

{% endblock content %}

movies/templates/movies/lists.html
{% extends 'base.html' %}

{% block title %}
Listas
{% endblock title %}

{% block content %}
<h2>Listas de Filmes</h2>

<section>
    {% for list in list_list %}
    <hr>
    <article>
        <header>
            <h3>{{list.name}} (de {{ list.author }}) </h3>
        </header>
        <div class="lista-de-cards">
            {% for movie in list.movies.all %}
            <div class="card">
                <a href="{% url 'movies:detail' movie.id %}"><img src="{{ movie.poster_url }}"
                        alt="Poster do filme {{ movie.name}}"></a>
                <p>{{ movie.name }} ({{ movie.release_year }})</p>
            </div>
            {% endfor %}
        </div>
    </article>
    {% endfor %}

    <a href="{% url 'movies:create-list' %}"><button>Crie sua Lista</button></a>
</section>

{% endblock content %}

movies/templates/movies/review.html
{% extends 'base.html' %}

{% block content %}
<h2>Resenhar Filme {{ movie.name }} ({{ movie.release_year }})</h2>

<form action="{% url 'movies:review' movie.id %}" method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Postar Resenha</button>
</form>

<p><a href="{% url 'movies:detail' movie.id %}">Voltar para a página do filme</a></p>
{% endblock content %}

movies/templates/movies/search.html
{% extends 'base.html' %}

{% block content %}
<h2>Busca de Filmes por Nome</h2>
<form action="{% url 'movies:search' %}">
    <p>
        <label for="id_query">Título:</label>
        <input type="text" name="query" id="id_query" />
    </p>
    <button type="submit">Buscar</button>
</form>


<h2>Resultado da Busca</h2>
{% if movie_list %}
<section class="lista-de-cards">
    {% for movie in movie_list %}
    <article class="card">
        <img src="{{ movie.poster_url }}" alt="Poster do filme {{ movie.name}}">
        <p>{{ movie.name }} ({{ movie.release_year }})</p>
    </article>
    {% endfor %}
</section>
{% else %}
<p>Não foi encontrado nenhum filme para a busca.</p>
{% endif %}

{% endblock content %}

movies/templates/movies/update.html
{% extends 'base.html' %}

{% block content %}
<h2>Atualizar Dados do Filme {{ movie.name }}({{ movie.release_year}})</h2>
<form method="POST" action="{% url 'movies:update' movie.id%}">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Atualizar</button>
</form>

{% endblock content %}

staticpages/templates/staticpages/about.html
{% extends 'base.html' %}

{% block title %}
Sobre
{% endblock title %}

{% block content %}
<h2>Sobre este site</h2>
{% endblock content %}

staticpages/templates/staticpages/index.html
{% extends 'base.html' %}

{% block title %}
Página Inicial
{% endblock title %}

{% block content %}
<h1><i>Watch that film!</i></h1>
<p>A Página para Comunidade Resenhadora de Filmes</p>
{% endblock content %}

templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>
        {% block title %}{% endblock %} | Watch that film!
    </title>
    <link href="https://fonts.googleapis.com/css?family=Inter&display=swap" rel="stylesheet" />
    <link rel="stylesheet" type="text/css" href="{% static 'style.css' %}">
</head>

<body>
    <header id="cabecalho-principal">
        <a href="{% url 'index' %}"> <img src="{% static 'logo.svg' %}"> </a>
        <nav id="navegacao-principal">
            <ul>
                <li><a href="{% url 'movies:index' %}">Filmes</a></li>
                <li><a href="{% url 'about' %}">Sobre</a></li>
                <li><a href="{% url 'movies:lists' %}">Listas</a></li> <!-- adicionar esta linha -->
            </ul>
        </nav>

    </header>
    <main id="conteiner-principal">
        {% block content %}
        {% endblock content %}
    </main>
    <footer id="rodape-principal">
        <p>
            <small>Copyright 2021</small>
        </p>
    </footer>
</body>

</html>